using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Server
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private AxVCProX.AxvcproIpServerX ipServerSpeak;
		private AxVCProX.AxvcproIpServerX ipServerListen;
		private System.Timers.Timer timer1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.ComboBox cbSpeakerProtocol;
		private System.Windows.Forms.ComboBox cbListenerProtocol;
		private System.Windows.Forms.TextBox tbSpeakerPort;
		private System.Windows.Forms.TextBox tbListenerPort;
		private System.Windows.Forms.Label lbSpeaker;
		private System.Windows.Forms.Label lbListener;
		private System.Windows.Forms.TextBox tbNumClients;
		private System.Windows.Forms.Label laBytesReceived;
		private System.Windows.Forms.Label laBytesSent;
		private System.Windows.Forms.TextBox tbLog;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.ipServerSpeak = new AxVCProX.AxvcproIpServerX();
            this.ipServerListen = new AxVCProX.AxvcproIpServerX();
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.timer1 = new System.Timers.Timer();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.lbSpeaker = new System.Windows.Forms.Label();
            this.tbSpeakerPort = new System.Windows.Forms.TextBox();
            this.cbSpeakerProtocol = new System.Windows.Forms.ComboBox();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.lbListener = new System.Windows.Forms.Label();
            this.tbListenerPort = new System.Windows.Forms.TextBox();
            this.cbListenerProtocol = new System.Windows.Forms.ComboBox();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.tbNumClients = new System.Windows.Forms.TextBox();
            this.laBytesReceived = new System.Windows.Forms.Label();
            this.laBytesSent = new System.Windows.Forms.Label();
            this.tbLog = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            ((System.ComponentModel.ISupportInitialize)(this.ipServerSpeak)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.ipServerListen)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.timer1)).BeginInit();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.SuspendLayout();
            // 
            // ipServerSpeak
            // 
            this.ipServerSpeak.Enabled = true;
            this.ipServerSpeak.Location = new System.Drawing.Point(200, 144);
            this.ipServerSpeak.Name = "ipServerSpeak";
            this.ipServerSpeak.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("ipServerSpeak.OcxState")));
            this.ipServerSpeak.Size = new System.Drawing.Size(72, 32);
            this.ipServerSpeak.TabIndex = 0;
            // 
            // ipServerListen
            // 
            this.ipServerListen.Enabled = true;
            this.ipServerListen.Location = new System.Drawing.Point(200, 200);
            this.ipServerListen.Name = "ipServerListen";
            this.ipServerListen.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("ipServerListen.OcxState")));
            this.ipServerListen.Size = new System.Drawing.Size(72, 32);
            this.ipServerListen.TabIndex = 2;
            this.ipServerListen.OnClientDisconnect += new AxVCProX.IvcproIpServerEvents_OnClientDisconnectEventHandler(this.ipServerListen_OnClientDisconnect);
            this.ipServerListen.OnClientConnect += new AxVCProX.IvcproIpServerEvents_OnClientConnectEventHandler(this.ipServerListen_OnClientConnect);
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(200, 16);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(88, 24);
            this.button1.TabIndex = 4;
            this.button1.Text = "Start";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(200, 48);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(88, 24);
            this.button2.TabIndex = 5;
            this.button2.Text = "Stop";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // timer1
            // 
            this.timer1.Enabled = true;
            this.timer1.Interval = 500;
            this.timer1.SynchronizingObject = this;
            this.timer1.Elapsed += new System.Timers.ElapsedEventHandler(this.timer1_Elapsed);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.lbSpeaker);
            this.groupBox1.Controls.Add(this.tbSpeakerPort);
            this.groupBox1.Controls.Add(this.cbSpeakerProtocol);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(88, 120);
            this.groupBox1.TabIndex = 7;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Speaker";
            // 
            // lbSpeaker
            // 
            this.lbSpeaker.AutoSize = true;
            this.lbSpeaker.Location = new System.Drawing.Point(8, 98);
            this.lbSpeaker.Name = "lbSpeaker";
            this.lbSpeaker.Size = new System.Drawing.Size(55, 13);
            this.lbSpeaker.TabIndex = 4;
            this.lbSpeaker.Text = "lbSpeaker";
            // 
            // tbSpeakerPort
            // 
            this.tbSpeakerPort.Location = new System.Drawing.Point(8, 72);
            this.tbSpeakerPort.Name = "tbSpeakerPort";
            this.tbSpeakerPort.Size = new System.Drawing.Size(72, 20);
            this.tbSpeakerPort.TabIndex = 3;
            this.tbSpeakerPort.Text = "17860";
            // 
            // cbSpeakerProtocol
            // 
            this.cbSpeakerProtocol.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbSpeakerProtocol.Items.AddRange(new object[] {
            "TCP",
            "UDP"});
            this.cbSpeakerProtocol.Location = new System.Drawing.Point(8, 32);
            this.cbSpeakerProtocol.Name = "cbSpeakerProtocol";
            this.cbSpeakerProtocol.Size = new System.Drawing.Size(72, 21);
            this.cbSpeakerProtocol.TabIndex = 2;
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(8, 56);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(26, 13);
            this.label3.TabIndex = 1;
            this.label3.Text = "Port";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(8, 16);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(46, 13);
            this.label2.TabIndex = 0;
            this.label2.Text = "Protocol";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.lbListener);
            this.groupBox2.Controls.Add(this.tbListenerPort);
            this.groupBox2.Controls.Add(this.cbListenerProtocol);
            this.groupBox2.Controls.Add(this.label4);
            this.groupBox2.Controls.Add(this.label5);
            this.groupBox2.Location = new System.Drawing.Point(104, 8);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(88, 120);
            this.groupBox2.TabIndex = 8;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Listener";
            // 
            // lbListener
            // 
            this.lbListener.AutoSize = true;
            this.lbListener.Location = new System.Drawing.Point(8, 98);
            this.lbListener.Name = "lbListener";
            this.lbListener.Size = new System.Drawing.Size(52, 13);
            this.lbListener.TabIndex = 6;
            this.lbListener.Text = "lbListener";
            // 
            // tbListenerPort
            // 
            this.tbListenerPort.Location = new System.Drawing.Point(8, 72);
            this.tbListenerPort.Name = "tbListenerPort";
            this.tbListenerPort.Size = new System.Drawing.Size(72, 20);
            this.tbListenerPort.TabIndex = 5;
            this.tbListenerPort.Text = "17861";
            // 
            // cbListenerProtocol
            // 
            this.cbListenerProtocol.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbListenerProtocol.Items.AddRange(new object[] {
            "TCP",
            "UDP"});
            this.cbListenerProtocol.Location = new System.Drawing.Point(8, 32);
            this.cbListenerProtocol.Name = "cbListenerProtocol";
            this.cbListenerProtocol.Size = new System.Drawing.Size(72, 21);
            this.cbListenerProtocol.TabIndex = 4;
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(8, 56);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(26, 13);
            this.label4.TabIndex = 3;
            this.label4.Text = "Port";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(8, 16);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(46, 13);
            this.label5.TabIndex = 2;
            this.label5.Text = "Protocol";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(200, 80);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(89, 13);
            this.label1.TabIndex = 9;
            this.label1.Text = "Number of clients";
            // 
            // tbNumClients
            // 
            this.tbNumClients.Location = new System.Drawing.Point(200, 96);
            this.tbNumClients.Name = "tbNumClients";
            this.tbNumClients.ReadOnly = true;
            this.tbNumClients.Size = new System.Drawing.Size(40, 20);
            this.tbNumClients.TabIndex = 10;
            this.tbNumClients.Text = "0";
            // 
            // laBytesReceived
            // 
            this.laBytesReceived.AutoSize = true;
            this.laBytesReceived.Location = new System.Drawing.Point(8, 136);
            this.laBytesReceived.Name = "laBytesReceived";
            this.laBytesReceived.Size = new System.Drawing.Size(87, 13);
            this.laBytesReceived.TabIndex = 11;
            this.laBytesReceived.Text = "laBytesReceived";
            // 
            // laBytesSent
            // 
            this.laBytesSent.AutoSize = true;
            this.laBytesSent.Location = new System.Drawing.Point(8, 152);
            this.laBytesSent.Name = "laBytesSent";
            this.laBytesSent.Size = new System.Drawing.Size(63, 13);
            this.laBytesSent.TabIndex = 12;
            this.laBytesSent.Text = "laBytesSent";
            // 
            // tbLog
            // 
            this.tbLog.Location = new System.Drawing.Point(8, 168);
            this.tbLog.Multiline = true;
            this.tbLog.Name = "tbLog";
            this.tbLog.ReadOnly = true;
            this.tbLog.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.tbLog.Size = new System.Drawing.Size(184, 64);
            this.tbLog.TabIndex = 13;
            this.tbLog.WordWrap = false;
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(200, 128);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(47, 13);
            this.label6.TabIndex = 14;
            this.label6.Text = "Speaker";
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(200, 184);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(44, 13);
            this.label7.TabIndex = 15;
            this.label7.Text = "Listener";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(298, 239);
            this.Controls.Add(this.tbLog);
            this.Controls.Add(this.laBytesSent);
            this.Controls.Add(this.laBytesReceived);
            this.Controls.Add(this.tbNumClients);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.ipServerListen);
            this.Controls.Add(this.ipServerSpeak);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.label1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.Text = "RemoteLecturer Server :: (C) Lake of Soft";
            this.Closed += new System.EventHandler(this.Form1_Closed);
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.ipServerSpeak)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.ipServerListen)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.timer1)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void SetLink(VCProX.IvcproProvider provider, VCProX.IvcproConsumer consumer)
		{
			provider.AddConsumer(consumer);
		}

		private void button1_Click(object sender, System.EventArgs e)
		{

		   ipServerSpeak.Proto = (VCProX.unaProtoType) cbSpeakerProtocol.SelectedIndex;
			ipServerSpeak.Port = tbSpeakerPort.Text;
			ipServerListen.Proto = (VCProX.unaProtoType) cbListenerProtocol.SelectedIndex;
			ipServerListen.Port = tbListenerPort.Text;

			ipServerSpeak.Active = true;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			ipServerSpeak.Active = false;
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			cbSpeakerProtocol.SelectedIndex = 1;
			cbListenerProtocol.SelectedIndex = 1;

			SetLink((VCProX.IvcproProvider)ipServerSpeak.GetOcx(), (VCProX.IvcproConsumer)ipServerListen.GetOcx());
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			ipServerSpeak.Active = false;
		}

		private void timer1_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
		{
         button1.Enabled = !ipServerSpeak.Active || !ipServerListen.Active;
			button2.Enabled = !button1.Enabled;

			lbSpeaker.Text = ipServerSpeak.Active ? "active" : "not active";
			lbListener.Text = ipServerListen.Active ? "active" : "not active";

			tbNumClients.Text = ipServerListen.ClientCount.ToString();

			laBytesReceived.Text = "bytes received: " + ipServerSpeak.BytesReceived.ToString();
			laBytesSent.Text = "bytes sent: " + ipServerListen.BytesSent.ToString();
		}

		private void ipServerListen_OnClientConnect(object sender, AxVCProX.IvcproIpServerEvents_OnClientConnectEvent e)
		{
         // use IpServer.GetClientParam to retreive client params
			tbLog.Text += "listener connected\r\n";
		}

		private void ipServerListen_OnClientDisconnect(object sender, AxVCProX.IvcproIpServerEvents_OnClientDisconnectEvent e)
		{
			// use IpServer.GetClientParam to retreive client params
			tbLog.Text += "listener disconnected\r\n";
		}
	}
}
